;==========================================================================
;  Anwendung:		TOR2-Verbindung (z.B. mit PC)
;
;	Autor:			E.Mueller
;
;	erstellt:		14.01.2007
;	gendert:		21.03.2008
;
;	Prozessor:		U883
;	Takt:				8 MHz
;	geeignet fr:	JU+TE mit 4K Betriebssystem
;
;	Anschlu z.B. an PC
;
;  parallele                JU+TE
;  Schnittstelle            TOR2
;      D0 (2)  <---R100--->  P20
;      D1 (3)  <---R100--->  P21
;      D2 (4)  <---R100--->  P22
;      D3 (5)  <---R100--->  P23
;      D4 (6)  <---R100--->  P24
;      D5 (7)  <---R100--->  P25
;      D6 (8)  <---R100--->  P26
;      D7 (9)  <---R100--->  P27
;   Masse (0)  <---------->  Masse
;
;==========================================================================
;f. Arnold-Assembler
;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255

	cpu	z8601
	assume RP:0C0h		; keine Optimierung !

P2	EQu	2		; Port 2 
RP	EQU	0FDH		; Registerpointer
;==========================================================================


buchstabe	MACRO	r8
	ld	05Ah,#r8
	call	00827h
	ENDM

	;org 02800h
	org 0F800h
	jp	Anfang

zaehler	equ	045h
temp	equ	046h
temp_s	equ	047h
;r8	equ	r8
endekenner	equ	049h


	;Warteschleife
Warte:	push	rp
	srp	#020h
	ld	r0,#0ffh
   ld	r1,#00fh		;ggf. erhhen, falls Probleme beim Senden auftreten (Empfang bei PC o..)
wam:	djnz	r0,wam
   djnz	r1,wam
	pop	rp
  	ret

Anfang:	;Bereich voreinstellen
	ld	040h,#0E0h
	ld	041h,#00h
	ld	042h,#0F7h
	ld	043h,#0BFh
Haupt:	call	Z_Erste
	call	Z_Adresse
	call	Z_Letzte
	call	00C1Dh	;Tastenabfrage
	cp	05Ah,#'Z'
	jr	nz,stw1
	ret	;Rckkehr
stw1:	cp	05Ah,#'S'
	jr	nz,stw2
	call	Senden
	jp	Haupt
stw2:	cp	05Ah,#'E'
	jr	nz,stw3
	call	Z_Frage_Bereit
	call	00C1Dh	;Tastenabfrage
	cp	05Ah,#'N'
	jp	Z,Haupt
	call	Empfangen
	jp	Haupt
stw3:	cp	05Ah,#'B'
	jp	nz,Haupt
	call	Bereich
	jp	Haupt

Senden:	ld	04ah,040h	;Sicherung oberer Teil Startadresse
	ld	04bh,041h	;Sicherung unterer Teil Startadresse
	ld	0f6h,#00h	;Tor 2 als Ausgang
	di
	push rp
	srp #040h
	clr	P2	;auf Null setzen
	call Warte
	ld	P2,#0AAh	;Anfang
	call Warte
	;********** KOPF ************
	push	02fh
	ld	02fh,040h
	call	Kopf_Adressbyte
	ld	02fh,041h
	call	Kopf_Adressbyte
	ld	02fh,042h
	call	Kopf_Adressbyte
	ld	02fh,043h
	call	Kopf_Adressbyte
	pop	02fh
	ld	P2,#0C3h		;Trenner
	call Warte
	;********** ENDE KOPF ************
	incw	rr2		;Damit auch die letzte Postion kopiert wird !
sew1:	ldc r15,@rr0		;Hole Daten von Adresse
	and	r15,#0f0h	;oberer Teil
	swap	r15		;tauschen
	add 	r15,#010h		;Kennung oT laden
	ld	P2,r15		;Ausgabe
	call Warte
	ldc r15,@rr0		;Hole erneut Daten von Adresse
	and	r15,#00fh	;unterer Teil
	add	r15,#020h			;Kennung uT laden
	ld	P2,r15		;Ausgabe
	call Warte
	;Weiter
	incw rr0
	cp r2,r0
	jr nz,sew1	;oberer Teil nicht 0, dann weiter
	cp r3,r1
	jr nz,sew1	;unterer Teil nicht 0, dann weiter
	ld	P2,#055h	;Ende
	call Warte
	clr	P2		;auf Null setzen
	call Warte
	decw	rr2		;Was man verstellt mu man wieder richten
	pop rp
	ei
	ld	0f6h,#0ffh	;Tor 2 wieder als Eingang
	ld	040h,04ah	;Wiederherstellung oberer Teil Startadresse
	ld	041h,04bh	;Wiederherstellung unterer Teil Startadresse
	ret

Kopf_Adressbyte:	ld	04eh,02fh		;arbeite mit siko
	and	04eh,#0f0h	;oberer Teil
	swap	04eh		;tauschen
	ld	04fh,#010h		;Kennung oT laden
	add	04fh,04eh	;Verknpfen
	ld	P2,04fh		;Ausgabe
	call Warte
	ld	04eh,02fh		;arbeite mit siko
	and	04eh,#00fh	;unterer Teil
	ld	04fh,#020h		;Kennung uT laden
	add	04fh,04eh	;Verknpfen
	ld	P2,04fh		;Ausgabe
	call Warte
	ret

Empfangen:	;call	08ddh
	ld	0f6h,#0ffh	;Tor 2 als Eingang
	di
	push rp
	srp #040h
	;*** Kopf Anfang ***
	;Warte auf Anfang...
Empf_Weiter0:	;---Abbruchmglichkeit !
	call	00c56h			;dynamische Tastenabfrage
	ld	r8,06Dh
	and	r8,#01111111b	;T-Bit ausblenden
	cp	r8,#'A'
	jr	z,Empf_Weiter3
	cp	r8,#'X'
	jr	z,Empf_Weiter3
	;---Abbruchmglichkeit Ende
	cp	P2,#0AAh			;Anfang
	jr	NZ,Empf_Weiter0
	;Weiter Start-,Stopadresse H
	call	Warte_auf_Byte
	ld	040h,r8	;Start
	ld	042h,r8	;Stop
	;Weiter Start-,Stopadresse L
	call	Warte_auf_Byte
	ld	041h,r8	;Start
	ld	043h,r8	;Stop
	;Stop -1
	decw	rr2
	;Warte auf Trenner...
Empf_Weiter1:	;---Abbruchmglichkeit !
	call	00c56h			;dynamische Tastenabfrage
	ld	r8,06Dh
	and	r8,#01111111b	;T-Bit ausblenden
	cp	r8,#'A'
	jr	z,Empf_Weiter3
	cp	r8,#'X'
	jr	z,Empf_Weiter3
	;---Abbruchmglichkeit Ende
	cp	P2,#0C3h			;Trenner
	jr	NZ,Empf_Weiter1
	;*** Kopf Ende ***
	;Weiter Daten
Empf_Weiter2:	call	Warte_auf_Byte
	cp		endekenner,#2	;Ende
	jr	Z,Empf_Weiter3
	incw	rr2
	lde	@rr2,r8	;r8
	jr	Empf_Weiter2
Empf_Weiter3:	clr	06dh			;dynamisches Tasten-Register rcksetzen
	pop rp
	ei
	ret

	;Baut 1x und 2x zu einem Byte zusammen
Warte_auf_Byte:	ld	endekenner,#1
	;---Abbruchmglichkeit !
	call	00c56h			;dynamische Tastenabfrage
	ld	r9,06Dh
	and	r9,#01111111b	;T-Bit ausblenden
	cp	r9,#'A'
	jr	z,WaB_EndeZeichen
	cp	r9,#'X'
	jr	z,WaB_EndeZeichen
	;---Abbruchmglichkeit Ende
	;Warte auf 1
	ld	temp_s,P2
	ld	temp,temp_s
	;auf Ende-Zeichen berprfen
	cp	temp,#055h
	jr	Z,WaB_EndeZeichen
	;---
	swap	temp
	and	temp,#00fh
	cp	temp,#1
	jr	NZ,Warte_auf_Byte
	and	temp_s,#00fh
	swap	temp_s
	ld	r8,temp_s
	;Weiter, Warte auf 2
WaB_Weiter:	;---Abbruchmglichkeit !
	call	00c56h			;dynamische Tastenabfrage
	ld	r9,06Dh
	and	r9,#01111111b	;T-Bit ausblenden
	cp	r9,#'A'
	jr	z,WaB_EndeZeichen
	cp	r9,#'X'
	jr	z,WaB_EndeZeichen
	;---Abbruchmglichkeit Ende
	ld	temp_s,P2
	ld	temp,temp_s
	;auf Ende-Zeichen berprfen
	cp	temp,#055h
	jr	Z,WaB_EndeZeichen
	;---
	swap	temp
	and	temp,#00fh
	cp	temp,#2
	jr	NZ,WaB_Weiter
	and	temp_s,#00fh
	add	r8,temp_s
	ret
WaB_EndeZeichen:	ld	endekenner,#2
	ret

Bereich:	call	Z_Bereich1
	ld	02Ah,#024h	;von
	call	Adresse_eingeben
	call	00ACEh	;neue Zeile
	buchstabe 'B'
	buchstabe 'I'
	buchstabe 'S'
	buchstabe ':'
	ld	02Ah,#026h	;bis
	call	Adresse_eingeben
	call	Z_Bereich2
	call	00C1Dh	;Tastenabfrage
	cp	05Ah,#'J'
	jr	nz,bew1
	ld	040h,024h
	ld	041h,025h
	ld	042h,026h
	ld	043h,027h
bew1:	ret

Z_Adresse:	ld	05Eh,040h
	ld	05Fh,041h
	call	020DBh
	buchstabe '-'
	ld	05Eh,042h
	ld	05Fh,043h
	call	020DBh
	call	00ACEh	;neue Zeile
	call	00ACEh	;neue Zeile
	ret

Z_Erste:	push	r13
	push	r14
	push	r15
	ld	r15,#lo(Z_Erste_Bild)
	ld	r14,#hi(Z_Erste_Bild)
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Letzte:	push	r13
	push	r14
	push	r15
	ld	r15,#lo(Z_Letzte_Bild)
	ld	r14,#hi(Z_Letzte_Bild)
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Frage_Bereit:	push	r13
	push	r14
	push	r15
	ld	r15,#lo(Z_Frage_Bild)
	ld	r14,#hi(Z_Frage_Bild)
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Bereich1:	push	r13
	push	r14
	push	r15
	ld	r15,#lo(Z_Bereich1_Bild)
	ld	r14,#hi(Z_Bereich1_Bild)
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Bereich2:	push	r13
	push	r14
	push	r15
	ld	r15,#lo(Z_Bereich2_Bild)
	ld	r14,#hi(Z_Bereich2_Bild)
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Baue_Bild:	ldc	r13,@rr14
	cp	r13,#001h
	jr	z,BB_W1
	cp	r13,#002h
	jr	z,BB_W2
	cp	r13,#003h
	jr	z,BB_W3
	;normales Zeichen
	ld	05Ah,r13
	call	00827h
BB_W0:	incw	rr14
	jr	Baue_Bild
BB_W1:	call	008DDh	;Bildschirm lschen
	jr		BB_W0
BB_W2:	call	00ACEh	;neue Zeile
	jr		BB_W0
BB_W3:	ret

Z_Frage_Bild:	;001h Bildschirm lschen
	;002h neue Zeile
	;003h Ende
	db	001h
	db "BILD WIRD NUN"
	db "ABGESCHALTET!"
	db	002h
	db "ABBRUCH DURCH"
	db "TASTE A BZW X"
	db	002h
	db "BEREIT(J/N)?"
	db 003h

Z_Erste_Bild:	db	001h
	db "TOR2-VERBIND."
	db	002h
	db "B BEREICH"
	db	002h,003h

Z_Letzte_Bild:	db "E EMPFANGEN"
	db	002h
	db "S SENDEN"
	db 002h
	db "Z ZURUECK "
	db 003h

Z_Bereich1_Bild:	db	001h
	db "BEREICH"
	db	002h
	db "FESTLEGEN"
	db	002h,002h
	db "VON:"
	db	003h

Z_Bereich2_Bild:	db	002h,002h
	db "UEBERNEHMEN?"
	db	003h

Taste_erkannt:	ld	05Ah,022h		;Darstellen
	call	00827h
	ld	@02Fh,020h	;Lade Zeichen in Zwischenspeicher
	dec	02Fh			;Stellenzeiger Zwischenspeicher
	srp	#020h
	djnz	r3,Tastenabfrage
	rl	02Eh	;1.Stelle
	rl	02Eh
	rl	02Eh
	rl	02Eh
	and	02Eh,#0F0h
	rl	02Ch	;3.Stelle
	rl	02Ch
	rl	02Ch
	rl	02Ch
	and	02Ch,#0F0h
	add	02Eh,02Dh	;1.& 2.Stelle zusammenfhren
	add	02Ch,02Bh	;3.& 4.Stelle zusammenfhren
	ld	@02Ah,02Eh	;oberer Adressteil
	inc	02Ah
	ld	@02Ah,02Ch	;unterer Adressteil
	ret

Adresse_eingeben:	ld	023h,#004h		;Stellenzhler auf 4
	ld	02Fh,#02Eh		;Stellenzeiger
Tastenabfrage:	push	r13
	push	r14
	push	r15
Erl_Tast_W0:	ld	r15,#lo(Erlaubte_Tasten)
	ld	r14,#hi(Erlaubte_Tasten)
	call	00C1Dh	;Tastenabfrage
	ld	022h,05Ah
	clr	020h
Erl_Tast_W1:	ldc	r13,@rr14
	cp	022h,r13
	jr	Z,Erl_Tast_W2
	inc	020h
	cp	020h,#16
	jr	Z,Erl_Tast_W0
	incw	rr14
	jr	Erl_Tast_W1
Erl_Tast_W2:	pop	r15
	pop	r14
	pop	r13
	jp	Taste_erkannt

Erlaubte_Tasten:	db "0123456789ABCDEF"


end
